/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.144 by edhill, Sat Mar 11 02:53:48 2006 UTC revision 1.167 by jmc, Mon Nov 26 21:39:58 2007 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 317  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 356  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 gfortran"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 579  Usage: "$0" [OPTIONS] Line 587  Usage: "$0" [OPTIONS]
587      -ts | --ts      -ts | --ts
588            Produce timing information per timestep            Produce timing information per timestep
589      -papis | --papis      -papis | --papis
590            Produce summary MFlop/s with PAPI per timestep            Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593      -foolad | --foolad      -foolad | --foolad
594            Fool the AD code generator            Fool the AD code generator
595      -papi | --papi      -papi | --papi
596            Performance analysis with PAPI            Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599      -hpmt | --hpmt      -hpmt | --hpmt
600            Performance analysis with the HPM Toolkit            Performance analysis with the HPM Toolkit
601    
602      -gsl | --gsl      -gsl | --gsl
603            Use GSL to control floating point rounding and precision            Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
# Line 742  EOF Line 756  EOF
756        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
757        end        end
758  EOF  EOF
759      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
760        echo $COMM >> genmake_warnings
761        $COMM >> genmake_warnings 2>&1
762      RET_F=$?      RET_F=$?
763      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
764      RETVAL=$?      RETVAL=$?
# Line 755  EOF Line 771  EOF
771    
772    
773  check_HAVE_SIGREG()  {  check_HAVE_SIGREG()  {
774        if test ! "x$HAVE_SIGREG" = x ; then
775            return
776        fi
777      get_fortran_c_namemangling      get_fortran_c_namemangling
778      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
779  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 812  EOF Line 831  EOF
831    
832    
833  check_HAVE_SETRLSTK()  {  check_HAVE_SETRLSTK()  {
834        if test "x$HAVE_SETRLSTK" = xt ; then
835            DEFINES="$DEFINES -DHAVE_SETRLSTK"
836            return
837        fi  
838        if test ! "x$HAVE_SETRLSTK" = x ; then
839            return
840        fi
841      get_fortran_c_namemangling      get_fortran_c_namemangling
842      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
843  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 922  EOF Line 948  EOF
948      cat genmake_tnc.F >> genmake_tnc.log      cat genmake_tnc.F >> genmake_tnc.log
949      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
950      RET_CPP=f      RET_CPP=f
951      COMM="$CPP $DEFINES $INCLUDES genmake_tnc.F"      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
952      echo "$COMM" >> genmake_tnc.log      echo "$COMM" >> genmake_tnc.log
953      $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t      eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
954      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
955          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
956              >> genmake_tnc.log              >> genmake_tnc.log
# Line 932  EOF Line 958  EOF
958              >> genmake_tnc.log              >> genmake_tnc.log
959      fi      fi
960      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
961      echo "  &&  $LINK -o genmake_tnc.o $LIBS" >> genmake_tnc.log      echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
962      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
963          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
964      RET_COMPILE=$?      RET_COMPILE=$?
965      cat genmake_tnc.log >> genmake_warnings      cat genmake_tnc.log >> genmake_warnings
966    
# Line 950  EOF Line 976  EOF
976      else      else
977          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
978          echo "try again with added '-lnetcdf'" > genmake_tnc.log          echo "try again with added '-lnetcdf'" > genmake_tnc.log
979          echo "$CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS \ " >> genmake_tnc.log          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
980          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
981          echo " &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log          echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
982          $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \          cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
983              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
984              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1              &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
985          RET_COMPILE=$?          RET_COMPILE=$?
986          cat genmake_tnc.log >> genmake_warnings          cat genmake_tnc.log >> genmake_warnings
987          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
988              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
989              HAVE_NETCDF=t              HAVE_NETCDF=t
990            else
991            # try again with "-lnetcdff" added to the libs
992                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
993                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
994                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
995                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
996                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
997                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
998                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
999                RET_COMPILE=$?
1000                cat genmake_tnc.log >> genmake_warnings
1001                if test "x$RET_COMPILE" = x0 ; then
1002                    LIBS="$LIBS -lnetcdff -lnetcdf"
1003                    HAVE_NETCDF=t
1004                fi
1005          fi          fi
1006      fi      fi
1007      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 996  OPTFILE= Line 1037  OPTFILE=
1037  INCLUDES="-I. $INCLUDES"  INCLUDES="-I. $INCLUDES"
1038  FFLAGS=  FFLAGS=
1039  FOPTIM=  FOPTIM=
1040    FEXTRAFLAGS=
1041  CFLAGS=  CFLAGS=
1042  KFLAGS1=  KFLAGS1=
1043  KFLAGS2=  KFLAGS2=
# Line 1008  MPI= Line 1050  MPI=
1050  MPIPATH=  MPIPATH=
1051  TS=  TS=
1052  PAPIS=  PAPIS=
1053    PCLS=
1054  FOOLAD=  FOOLAD=
1055  PAPI=  PAPI=
1056    PCL=
1057  HPMT=  HPMT=
1058  GSL=  GSL=
1059    DEVEL=
1060  HAVE_TEST_L=  HAVE_TEST_L=
1061    
1062  # DEFINES checked by test compilation or command-line  # DEFINES checked by test compilation or command-line
# Line 1019  HAVE_SYSTEM= Line 1064  HAVE_SYSTEM=
1064  HAVE_FDATE=  HAVE_FDATE=
1065  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1066  HAVE_CLOC=  HAVE_CLOC=
1067  HAVE_SETRLSTK=  # HAVE_SETRLSTK=
1068  HAVE_STAT=  HAVE_STAT=
1069  HAVE_NETCDF=  HAVE_NETCDF=
1070  HAVE_ETIME=  HAVE_ETIME=
# Line 1070  TAMC_EXTRA= Line 1115  TAMC_EXTRA=
1115    
1116  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1117  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1118  gm_s2="FC CPP IEEE TS PAPIS PAPI HPMT GSL MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1119    
1120  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1121  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1122  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1123  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1124  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
# Line 1100  EOF Line 1145  EOF
1145    
1146  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
1147  gm_local="genmake_local"  gm_local="genmake_local"
 for i in . $MODS ; do  
     if test -r $i/$gm_local ; then  
         . $i/$gm_local  
         break  
     fi  
 done  
1148  printf "  getting local config information:  "  printf "  getting local config information:  "
1149  if test -f $gm_local ; then  if test -f $gm_local ; then
1150      echo "using $gm_local"      echo "using $gm_local"
# Line 1254  for ac_option in "$@" ; do Line 1293  for ac_option in "$@" ; do
1293              TS=true ;;              TS=true ;;
1294          -papis | --papis)          -papis | --papis)
1295              PAPIS=true ;;              PAPIS=true ;;
1296            -pcls | --pcls)
1297                PCLS=true ;;
1298          -foolad | --foolad)          -foolad | --foolad)
1299              FOOLAD=true ;;              FOOLAD=true ;;
1300          -papi | --papi)          -papi | --papi)
1301              PAPI=true ;;              PAPI=true ;;
1302            -pcl | --pcl)
1303                PCL=true ;;
1304          -hpmt | --hpmt)          -hpmt | --hpmt)
1305              HPMT=true ;;              HPMT=true ;;
1306    
1307          -gsl | --gsl)          -gsl | --gsl)
1308              GSL=true ;;              GSL=true ;;
1309    
1310            -devel | --devel)
1311                DEVEL=true ;;
1312    
1313          -mpi | --mpi)          -mpi | --mpi)
1314              MPI=true ;;              MPI=true ;;
1315          -mpi=* | --mpi=*)          -mpi=* | --mpi=*)
# Line 1312  done Line 1358  done
1358  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1359      echo      echo
1360      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1361      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1362      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1363      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1364      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1365      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1366      echo      echo
1367  fi  fi
1368    
1369  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1370  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1371      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1372      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1373          ROOTDIR=".."          ROOTDIR=".."
1374      else      else
1375          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1514  if test ! "x$TS" = x ; then Line 1559  if test ! "x$TS" = x ; then
1559        else        else
1560              DEFINES="$DEFINES -DTIME_PER_TIMESTEP"              DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1561        fi        fi
1562          PACKAGES="$PACKAGES showflops"
1563  fi  fi
1564  if test ! "x$PAPIS" = x ; then  if test ! "x$PAPIS" = x ; then
1565        echo "  Turning on PAPI flop summary per timestep"        echo "  Turning on PAPI flop summary per timestep"
# Line 1525  if test ! "x$PAPIS" = x ; then Line 1571  if test ! "x$PAPIS" = x ; then
1571        fi        fi
1572        INCLUDES="$INCLUDES $PAPIINC"        INCLUDES="$INCLUDES $PAPIINC"
1573        LIBS="$LIBS $PAPILIB"        LIBS="$LIBS $PAPILIB"
1574          PACKAGES="$PACKAGES showflops"
1575    fi
1576    if test ! "x$PCLS" = x ; then
1577          echo "  Turning on PCL counter summary per timestep"
1578          echo "  Please make sure PCLINC, PCLLIB are defined"
1579          if test ! "x$FOOLAD" = x ; then
1580                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1581          else
1582                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1583          fi
1584          INCLUDES="$INCLUDES $PCLINC"
1585          LIBS="$LIBS $PCLLIB"
1586          PACKAGES="$PACKAGES showflops"
1587  fi  fi
1588  if test ! "x$PAPI" = x ; then  if test ! "x$PAPI" = x ; then
1589        if test ! "x$PAPIS" = x ; then        if test ! "x$PAPIS" = x ; then
# Line 1538  if test ! "x$PAPI" = x ; then Line 1597  if test ! "x$PAPI" = x ; then
1597            LIBS="$LIBS $PAPILIB"            LIBS="$LIBS $PAPILIB"
1598        fi        fi
1599  fi  fi
1600    if test ! "x$PCL" = x ; then
1601          if test ! "x$PCLS" = x ; then
1602              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1603              echo "  Sticking with PCL flop summary per timestep!"
1604          else
1605              echo "  Turning on performance analysis with PCL"
1606              echo "  Please make sure PCLINC, PCLLIB are defined"
1607              DEFINES="$DEFINES -DUSE_PCL"
1608              INCLUDES="$INCLUDES $PCLINC"
1609              LIBS="$LIBS $PCLLIB"
1610          fi
1611    fi
1612  if test ! "x$HPMT" = x ; then  if test ! "x$HPMT" = x ; then
1613        if test ! "x$PAPI" = x ; then        if test ! "x$PAPI" = x ; then
1614            echo "  PAPI and the HPM Toolkit cannot co-exist!"            echo "  PAPI and the HPM Toolkit cannot co-exist!"
1615            echo "  Sticking with PAPI!"            echo "  Sticking with PAPI!"
1616          else if test ! "x$PCL" = x ; then
1617              echo "  PCL and the HPM Toolkit cannot co-exist!"
1618              echo "  Sticking with PCL!"
1619        else        else
1620            echo "  Turning on performance analysis with the HPM Toolkit"            echo "  Turning on performance analysis with the HPM Toolkit"
1621            echo "  Please make sure HPMTINC, HPMTLIB are defined"            echo "  Please make sure HPMTINC, HPMTLIB are defined"
# Line 1549  if test ! "x$HPMT" = x ; then Line 1623  if test ! "x$HPMT" = x ; then
1623            INCLUDES="$INCLUDES $HPMTINC"            INCLUDES="$INCLUDES $HPMTINC"
1624            LIBS="$LIBS $HPMTLIB"            LIBS="$LIBS $HPMTLIB"
1625        fi        fi
1626          fi
1627  fi  fi
1628  if test ! "x$GSL" = x ; then  if test ! "x$GSL" = x ; then
1629        echo "  Turning on use of GSL to control floating point calculations"        echo "  Turning on use of GSL to control floating point calculations"
# Line 1636  rm -f genmake_t* Line 1711  rm -f genmake_t*
1711    
1712  printf "  Can we unlimit the stack size using $FC...  "  printf "  Can we unlimit the stack size using $FC...  "
1713  check_HAVE_SETRLSTK  check_HAVE_SETRLSTK
1714  if test "x$HAVE_SETRLSTK" != x ; then  if test "x$HAVE_SETRLSTK" = xt ; then
1715      echo "yes"      echo "yes"
1716  else  else
1717      echo "no"      echo "no"
# Line 1645  rm -f genmake_t* Line 1720  rm -f genmake_t*
1720    
1721  printf "  Can we register a signal handler using $FC...  "  printf "  Can we register a signal handler using $FC...  "
1722  check_HAVE_SIGREG  check_HAVE_SIGREG
1723  if test "x$HAVE_SIGREG" != x ; then  if test "x$HAVE_SIGREG" = xt ; then
1724      echo "yes"      echo "yes"
1725  else  else
1726      echo "no"      echo "no"
# Line 1763  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1838  if test -r $ROOTDIR"/eesupp/src/Makefile
1838      fi      fi
1839  fi  fi
1840    
1841  #same for exch2  #same for pkg/exch2 and pkg/regrid
1842  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1843      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1844      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1845      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1846      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1847          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1848      else              rm -f make_${pdir}.errors
1849          echo "Error: problem encountered while building source files in exch2:"          else
1850          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1851          exit 1              cat make_${pdir}.errors 1>&2
1852                exit 1
1853            fi
1854      fi      fi
1855  fi  done
1856    
1857  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1858  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1886  done Line 1963  done
1963  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1964  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1965    
1966  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
1967  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
1968  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1969  RETVAL=$?  RETVAL=$?
1970  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1921  EOF Line 1998  EOF
1998      fi      fi
1999  fi  fi
2000    
2001    #  Check for package PROFILES: if NetCDF is not available,
2002    #  then delete profiles from the list of available packages.
2003    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2004    RETVAL=$?
2005    if test "x$RETVAL" = x0 ; then
2006        if test "x$HAVE_NETCDF" != xt ; then
2007            cat <<EOF
2008    
2009    *********************************************************************
2010    WARNING: the "profiles" package was enabled but tests failed to
2011      compile NetCDF applications.  Please check that:
2012    
2013      1) NetCDF is correctly installed for this compiler and
2014      2) the LIBS variable (within the "optfile") specifies the correct
2015           NetCDF library to link against.
2016    
2017      Due to this failure, the "profiles" package is now DISABLED.
2018    *********************************************************************
2019    
2020    EOF
2021            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2022            DISABLE="$DISABLE profiles"
2023        fi
2024    fi
2025    
2026  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2027  ck=  ck=
2028  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2029      i=0      i=0
2030      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2031      rtot=$nname      rtot=$nname
2032      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2033    
2034          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2035          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1961  while test "x$ck" != xtt ; do Line 2063  while test "x$ck" != xtt ; do
2063    
2064          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2065          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2066                #echo "   " $pname ": need to add :" $dname
2067              in_dis="f"              in_dis="f"
2068              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2069                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 2150  if test ! "x$DIVA" = x ; then Line 2253  if test ! "x$DIVA" = x ; then
2253          perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h          perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2254      else      else
2255          echo " We cannot create a copy of mpif.h!"          echo " We cannot create a copy of mpif.h!"
2256          exit -1  #       exit -1
2257      fi      fi
2258  fi  fi
2259    
# Line 2353  INCLUDES = ${INCLUDES} Line 2456  INCLUDES = ${INCLUDES}
2456  KFLAGS1 = ${KFLAGS1}  KFLAGS1 = ${KFLAGS1}
2457  KFLAGS2 = ${KFLAGS2}  KFLAGS2 = ${KFLAGS2}
2458  # Optim./debug for FC  # Optim./debug for FC
2459  FFLAGS = ${FFLAGS}  FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2460  FOPTIM = ${FOPTIM}  FOPTIM = ${FOPTIM}
2461  # Optim./debug for FC  # Optim./debug for FC
2462  F90FLAGS = ${F90FLAGS}  F90FLAGS = ${F90FLAGS}
# Line 2401  lib: libmitgcmuv.a Line 2504  lib: libmitgcmuv.a
2504    
2505  libmitgcmuv.a: \$(OBJFILES)  libmitgcmuv.a: \$(OBJFILES)
2506          ar rcv libmitgcmuv.a \$(OBJFILES)          ar rcv libmitgcmuv.a \$(OBJFILES)
2507            ar d   libmitgcmuv.a main.o
2508    
2509  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2510    
# Line 2411  output.txt: \$(EXECUTABLE) Line 2515  output.txt: \$(EXECUTABLE)
2515          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2516    
2517  clean:  clean:
2518          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2519            -rm -rf *.o
2520            -rm -rf *.$FS
2521  Clean:  Clean:
2522          @make clean          @make clean
2523          @make cleanlinks          @make cleanlinks
2524          -rm -f \$(SPECIAL_FILES)          -rm -f \$(SPECIAL_FILES)
2525          -rm -f genmake* make.log run.log *.bak          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
2526            -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2527  CLEAN:  CLEAN:
2528          @make Clean          @make Clean
2529          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2530          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2531          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2532          -rm -f \$(EXECUTABLE) *.txt STD* *diagnostics.log datetime          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2533            -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2534          -rm -rf mnc_test_*          -rm -rf mnc_test_*
2535    
2536  #eh3 Makefile: makefile  #eh3 Makefile: makefile
# Line 2481  cat >>$MAKEFILE <<EOF Line 2589  cat >>$MAKEFILE <<EOF
2589          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2590  .$FS.o:  .$FS.o:
2591          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2592  .F90.$FS90:  .F90.o:  
         \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@  
 .$FS90.o:  
2593          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2594  .c.o:  .c.o:
2595          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
# Line 2510  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2616  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2616  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2617  for i in $ad_vars ; do  for i in $ad_vars ; do
2618      name=$i      name=$i
2619      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2620      eval $t1      eval $t1
2621      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2622      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2623  done  done
2624    
2625  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
# Line 2530  rm -f ad_files Line 2636  rm -f ad_files
2636  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2637    
2638  # ... AD ...  # ... AD ...
2639  adall: ad_taf  adall: \$(EXE_AD)
2640  adtaf: ad_taf_output.$FS  adtaf: ad_taf_output.$FS
2641  adtamc: ad_tamc_output.$FS  adtamc: ad_tamc_output.$FS
2642    
# Line 2550  adtafonly: Line 2656  adtafonly:
2656          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2657          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2658    
2659  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2660          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2661    
2662  ad_tamc_output.$FS: ad_input_code.$FS  ad_tamc_output.$FS: ad_input_code.$FS
2663          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS

Legend:
Removed from v.1.144  
changed lines
  Added in v.1.167

  ViewVC Help
Powered by ViewVC 1.1.22